<p>Prije no što krenemo govoriti o digitalnim ostvarenjima aritmetičkih sklopova, osvrnut ćemo se na problematiku zbrajanja na konceptualnoj razini.</p>

<p>Poluzbrajalo je komponenta (kombinacijski sklop) koji na ulazima prima dvije znamenke te računa njihovu sumu i prijenos.</p>

<p>Pogledajmo najprije primjer u dekadskom brojevnom sustavu. Zbrajanjem znamenaka 3 i 4 dobivamo rezultat 7, no zbrajanjem znamenaka 6 i 7 dobivamo rezultat koji nije zapisiv kao jedna znamenka već je dvoznamenkasti broj 13. Upravo iz tog razloga od poluzbrajala očekujemo dva podatka na izlazu: koja je znamenka rezultata (odnosno koeficijent uz potenciju <i>B</i><sup>0</sup> (gdje je <i>B</i> baza brojevnog sustava) i koji je prijenos (odnosno koji je koeficijent u zbroju uz potenciju <i>B</i><sup>1</sup>). U prvom slučaju, gdje smo zbrajali 3 i 4, znamenka rezultata je 7 i prijenos je 0. U drugom slučaju, gdje smo zbrajali 6 i 7, znamenka rezultata je 3 a prijenos 1.</p>

<p>Lagano je pokazati da kod poluzbrajala prijenos može biti isključivo 0 ili 1, neovisno o bazi u kojoj se provodi zbrajanje. Naime, minimalne vrijednosti pribrojnika su 0 i 0 čiji je zbroj 0, pa su tada i znamenka rezultata i prijenos jednaki 0. Ako su pribrojnici maksimalnih vrijednosti, onda zbrajamo <i>B</i>-1 i <i>B</i>-1 što je \(2 \cdot B - 2\) odnosno \(B + (B-2)\) što je zapravo \(1 \cdot B^1 + (B-2) \cdot B^0\), pa je znamenka rezultata jednaka <i>B-2</i> a prijenos jednak 1. U dekadskom brojevnom sustavu, takvu situaciju imamo kada zbrajamo 9 i 9; suma je 18 pa je znamenka rezultata 8 a prijenos 1. Uočite da je nemoguće da suma dvije dekadske znamenke bude 20 ili veća (čime bismo imali prijenos 2 ili veći).</p> 

<p>Interaktivna simulacija dekadskog poluzbrajala prikazana je u nastavku. Pribrojnike možete mijenjati klikom miša (lijevi klik: inkrement, desni klik: dekrement) ili povlačenjem (u lijevu stranu: smanjivanje, u desnu: povećavanje; iznos ovisi o tome koliko daleko povučete). Sklop je trenutno podešen tako da su mu pribrojnici 2 i 3. Promijenite ih tako da isprobate oba spomenuta slučaja: zbrajanje 3 i 4 te zbrajanje 6 i 7.</p>

<p>Pribrojnici su na simbolu sklopa označeni s <i>a</i> i <i>b</i>, znamenka rezultata s <i>r</i> a prijenos s <i>c</i><sub>out</sub> (od engleskog <i>carry<sub>output</sub></i>). U središtu simbola upisano je HA od engleskog <i>Half-adder</i>, odnosno <em>poluzbrajalo</em>.</p>

<script>
@#page-include#(adders.js)
</script>

<div style="text-align: center;">
<canvas id="myCanvas1" width="170" height="230" oncontextmenu="return false;"></canvas><br>
Dekadsko poluzbrajalo.
</div>

<script>
// Prvi primjer:
var addState1 = new additionState(1);
addState1.a[0].setValue(2);
addState1.b[0].setValue(3);

var model1 = [
  new adder("myCanvas1", addState1, 0, 10, false)
];

model1[0].offsetX = 20;
model1[0].showABLabels = false;

var sc1 = new scene("myCanvas1", model1, addState1);
sc1.drawAll();
</script>

<p>Dekadsko poluzbrajalo je kombinacijski sklop čiji je rad u potpunosti određen tablicom od 100 redaka, u kojoj za svaku vrijednost od <i>a</i> i svaku vrijednost od <i>b</i> piše koja je znamenka rezultata a koji prijenos. Kako za <i>a</i> imamo 10 mogućnosti (znamenke su od 0 do 9) i kako za <i>b</i> imamo 10 mogućnosti (znamenke od 0 do 9), ukupan broj kombinacija je \(10 \times 10 = 100\). Djelomični prikaz ove tablice dan je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica dekadskog poluzbrajala.</div>
<table class="mlTableCC mlTableVRl2">
<thead>
<tr><th><i>a</i></th><th><i>b</i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>2</td><td>2</td><td>0</td></tr>
<tr><td>0</td><td>3</td><td>3</td><td>0</td></tr>
<tr><td>0</td><td>4</td><td>4</td><td>0</td></tr>
<tr><td>0</td><td>5</td><td>5</td><td>0</td></tr>
<tr><td>0</td><td>6</td><td>6</td><td>0</td></tr>
<tr><td>0</td><td>7</td><td>7</td><td>0</td></tr>
<tr><td>0</td><td>8</td><td>8</td><td>0</td></tr>
<tr><td>0</td><td>9</td><td>9</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>2</td><td>0</td></tr>
<tr><td>1</td><td>2</td><td>3</td><td>0</td></tr>
<tr><td colspan="2">...</td><td>...</td><td>...</td></tr>
<tr><td>9</td><td>7</td><td>6</td><td>1</td></tr>
<tr><td>9</td><td>8</td><td>7</td><td>1</td></tr>
<tr><td>9</td><td>9</td><td>8</td><td>1</td></tr>
</tbody>
</table>
 
<p>Kvartarno poluzbrajalo je poluzbrajalo za brojevni sustav s bazom <i>B</i>=4. Interaktivna simulacija takvog zbrajala prikazana je nastavku. Isprobajte njegov rad.</p>

<div style="text-align: center;">
<canvas id="myCanvas2" width="170" height="230" oncontextmenu="return false;"></canvas><br>
Kvartarno poluzbrajalo.
</div>

<script>
// Prvi primjer:
var addState2 = new additionState(1);
addState2.a[0].setValue(1);
addState2.b[0].setValue(2);

var model2 = [
  new adder("myCanvas2", addState2, 0, 4, false)
];

model2[0].offsetX = 20;
model2[0].showABLabels = false;

var sc2 = new scene("myCanvas2", model2, addState2);
sc2.drawAll();
</script>

<p>Tablica koja opisuje rad ovog poluzbrajala prikazana je u nastavku. Tablica ima \(4 \times 4 = 16\) redaka.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 2.</span> Tablica kvartarnog poluzbrajala.</div>
<table class="mlTableCC mlTableVRl2">
<thead>
<tr><th><i>a</i></th><th><i>b</i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>2</td><td>2</td><td>0</td></tr>
<tr><td>0</td><td>3</td><td>3</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>2</td><td>0</td></tr>
<tr><td>1</td><td>2</td><td>3</td><td>0</td></tr>
<tr><td>1</td><td>3</td><td>0</td><td>1</td></tr>
<tr><td>2</td><td>0</td><td>2</td><td>0</td></tr>
<tr><td>2</td><td>1</td><td>3</td><td>0</td></tr>
<tr><td>2</td><td>2</td><td>0</td><td>1</td></tr>
<tr><td>2</td><td>3</td><td>1</td><td>1</td></tr>
<tr><td>3</td><td>0</td><td>3</td><td>0</td></tr>
<tr><td>3</td><td>1</td><td>0</td><td>1</td></tr>
<tr><td>3</td><td>2</td><td>1</td><td>1</td></tr>
<tr><td>3</td><td>3</td><td>2</td><td>1</td></tr>
</tbody>
</table>


<p>Binarno poluzbrajalo je poluzbrajalo za brojevni sustav s bazom <i>B</i>=2. Moguće znamenke su samo 0 i 1. Interaktivna simulacija takvog zbrajala prikazana je nastavku. Isprobajte njegov rad.</p>

<div style="text-align: center;">
<canvas id="myCanvas3" width="170" height="230" oncontextmenu="return false;"></canvas><br>
Binarno poluzbrajalo.
</div>

<script>
// Prvi primjer:
var addState3 = new additionState(1);
addState3.a[0].setValue(0);
addState3.b[0].setValue(0);

var model3 = [
  new adder("myCanvas3", addState3, 0, 2, false)
];

model3[0].offsetX = 20;
model3[0].showABLabels = false;

var sc3 = new scene("myCanvas3", model3, addState3);
sc3.drawAll();
</script>

<p>Tablica koja opisuje funkcionalnost binarnog poluzbrajala prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 3.</span> Tablica binarnog poluzbrajala.</div>
<table class="mlTableCC mlTableVRl2">
<thead>
<tr><th><i>a</i></th><th><i>b</i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>0</td><td>1</td></tr>
</tbody>
</table>

<p>Kod binarnog poluzbrajala svi ulazi i izlazi su jednobitne vrijednosti. Iz tog razloga, sklop možemo promatrati kao vektorsku Booleovu funkciju koja preslikava \((a,b) \rightarrow (r,c_{\text{out}})\). Komponente \(r\) i \(c_{\text{out}}\) određene su izrazima danim u nastavku, što je izravno vidljivo iz prethodno prikazane tablice istinitosti.
$$
r(a,b) = a \oplus b \\
c_{\text{out}}(a,b) = a \cdot b.
$$
</p>

<div class="mlImportant">
<p>Binarno poluzbrajalo važno je za razumijevanje izgradnje binarnog potpunog zbrajala. Provjerite jeste li shvatili njegovu funkciju te algebarske izraze kojima su opisani njegovi izlazi. Zapamtite te algebarske izraze (ili bolje: način na koji smo došli do njih).</p>
</div>

<h3>Digitalna izvedba poluzbrajala za <i>B</i>&gt;2</h3>

<p>Želimo li izgraditi digitalni sklop koji je ostvarenje poluzbrajala za bazu koja je veća od 2, najprije moramo riješiti jedan problem: pribrojnici te rezultat više nemaju samo dvije moguće vrijednosti, odnosno ne možemo ih smatrati Booleovim varijablama. A za sklopovsko ostvarenje trebamo upravo to.</p>

<p>Iz tog razloga, ono što najprije treba dogovoriti jest koji će se <em>kôd</em> koristiti za prikaz znamenaka. O kodovima smo već pričali, i detaljno smo se upoznali s kodovima za prikaz dekadskih znamenaka (BCD-kôd, Excess-3-kôd i drugi). U kojem god da smo brojevnom sustavu koji je veći od 2, moramo se dogovoriti koji ćemo kôd koristiti. Jednom kada smo to učinili, poluzbrajalo projektiramo na jednak način kao što smo to činili i sa svim ostalim kombinacijskim sklopovima: napišemo tablicu istinitosti i popunimo je.</p>

<p>Promotrimo slučaj <i>B</i>=4. Neka su kvartarne znamenke kodirane dvobitnim kôdnim riječima kako slijedi: \(0 \rightarrow 00\), \(1 \rightarrow 01\), \(2 \rightarrow 10\), \(3 \rightarrow 11\). Odgovarajuća tablica kombinacija prikazana je u nastavku.</p>
 
<div class="mlTableCaption"><span class="mlTblKey">Tablica 4.</span> Tablica kvartarnog poluzbrajala uz zadani kod.</div>
<table class="mlTableCC mlTableVRl3 mlTableVRl5 mlTableVRl7 mlTableVRl1d mlTableVRf2d">
<thead>
<tr><th><i>a</i><sub>1</sub></th><th><i>a</i><sub>0</sub></th><th><i>b</i><sub>1</sub></th><th><i>b</i><sub>0</sub></th><th><i>a</i></th><th><i>b</i></th><th><i>r</i></th><th><i>c<sub>out</sub></i></th><th><i>r</i><sub>1</sub></th><th><i>r</i><sub>0</sub></th><th><i>c<sub>out</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>0</td><td>0</td><td>1</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>0</td><td>0</td><td>2</td><td>2</td><td>0</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>3</td><td>3</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>1</td><td>1</td><td>1</td><td>2</td><td>0</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>0</td><td>1</td><td>2</td><td>3</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>1</td><td>1</td><td>3</td><td>0</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>0</td><td>0</td><td>2</td><td>0</td><td>2</td><td>0</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>0</td><td>1</td><td>2</td><td>1</td><td>3</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td><td>2</td><td>2</td><td>0</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>1</td><td>2</td><td>3</td><td>1</td><td>1</td><td>0</td><td>1</td><td>1</td></tr>
<tr><td>1</td><td>1</td><td>0</td><td>0</td><td>3</td><td>0</td><td>3</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>0</td><td>1</td><td>3</td><td>1</td><td>0</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>
<tr class="mlMarkedRow"><td>1</td><td>1</td><td>1</td><td>0</td><td>3</td><td>2</td><td>1</td><td>1</td><td>0</td><td>1</td><td>1</td></tr>
<tr><td>1</td><td>1</td><td>1</td><td>1</td><td>3</td><td>3</td><td>2</td><td>1</td><td>1</td><td>0</td><td>1</td></tr>
</tbody>
</table>

<p>Na koji je način ova tablica popunjena? Tablica se, konceptualno, sastoji od četiri dijela koja su razdvojena punim okomitim crtama.</p>

<ul>
<li>Prvi dio (prva četiri stupca) čine sve binarne kombinacije kôdnih riječi kojima su kodirane znamenke.</li>
<li>Drugi dio tablice (stupci 5 i 6) čine dekodirane vrijednosti: tu smo si zapisali koje su to točno znamenke dovedene na ulaz sklopa, na način da smo <em>dekodirali</em> dovedene kôdne riječi.</li>
<li>Treći dio tablice (stupci 7 i 8) sadrže rezultat provođenja aritmetičke operacije.</li>
<li>Konačno, četvrti dio tablice (stupci 9, 10 i 11) sadrže kodirani rezultat.</li>
</ul>

<p>Ovo sve lijepo možemo vidjeti na predposljednjem retku tablice koji je istaknut žutom bojom. U stupcima 1 i 2 nalazi se kôd znamenke <i>a</i>: piše 11. Dekodiranjem znamo da je vrijednost te znamenke 3, i to upisujemo u stupac 5. U stupcima 3 i 4 nalazi se kôd znamenke <i>b</i>: piše 10. Dekodiranjem znamo da je vrijednost te znamenke 2, pa to upisujemo u stupac 6. Sada znamo da zbrajamo 3 i 2 (pročitano iz stupca 5 i 6); rezultat je 11<sub>(4)</sub>, pa je znamenka rezultata 1 i prijenos je 1, što upisujemo u stupce 7 i 8. Konačno, znamenku rezultata (1) kodiramo pa dobivamo kôdnu riječ 01 što upisujemo u stupce 9 i 10; prijenos prepisujemo u stupac 11. Na jedan način popunili bismo i sve ostale retke.</p>

<p>Što smo ovime dobili? Dobili smo tablicu istinitosti vektorske Booleove funkcije \((a_1,a_0,b_1,b_0) \rightarrow (r_1,r_0,c_{\text{out}})\), čije su varijable zapisane u prva četiri stupca tablice a funkcije-komponente u posljednja tri stupca tablice. Ove funkcije možemo očitati, primjerice, kao sume minterma:
$$
r_1(a_1,a_0,b_1,b_0) = \sum m(2,3,5,6,8,9,12,15) \\
r_0(a_1,a_0,b_1,b_0) = \sum m(1,3,4,6,9,11,12,14) \\
c_{\text{out}}(a_1,a_0,b_1,b_0) = \sum m(7,10,11,13,14,15)
$$
pa pokušati minimizirati i potom nacrtati sklopovsko ostvarenje osnovnim logičkim sklopovima.
</p>

<p>Uz drugačiji kôd, tablica bi izgledala drugačije i Booleove funkcije bi bile drugačije.</p>

